#ifndef _READ_FILE_HPP_
#define _READ_FILE_HPP_

#include "include.hpp"
#include "basic_type.hpp"
#include "time_out.hpp"
#include "parameter.hpp"
#include "bed_file.hpp"

using namespace std;

bool initialize_configure(string &configure_file_name,
                          Data_description &data_dsp,
                          Data_matrix *data,
                          size_t &probe_number,
                          size_t &sample_number,
                          size_t &covariable_number);

bool read_data_thread(vector<string> *data_file,
                      Data_matrix *data,
                      size_t remainder,
                      size_t nproc);

Data_matrix* read_data_file(string &configure_file_name,
                    Data_matrix *data,
                    size_t &probe_number,
                    size_t &sample_number,
                    size_t nproc);

Data_matrix* read_data(string &configure_file_name,
                      Data_description &data_dsp,
                      size_t covariable_number,
                      size_t nproc,
                      Parameter &param);

#endif
