#ifndef _CGI_ANALYSIS_HPP_
#define _CGI_ANALYSIS_HPP_

#include "include.hpp"
#include "basic_type.hpp"
#include "ancova.hpp"
#include "bed_file.hpp"
#include "time_out.hpp"

typedef struct CGI_result
{
  gsl_vector *pvalue;
  gsl_vector *fdr;
}CGI_result;

void cgi_analysis_thread(Data_matrix *data,
                         size_t remainder,
                         size_t nproc,
                         Data_description *data_des,
                         CGI_description *cgi_des,
                         CGI_result *cgi_res);

void cgi_analysis(Data_matrix *data,
                  size_t nproc,
                  string &cgi_filename,
                  Data_description &data_des,
                  CGI_result &cgi_res,
                  CGI_description &cgi_des);

void fdr_range_cgi(CGI_result &cgi_res,
                   CGI_description &cgi_des,
                   Data_description &data_des);

#endif
