#ifndef _DMR_ANALYSIS_HPP_
#define _DMR_ANALYSIS_HPP_

#include "include.hpp"
#include "basic_type.hpp"
#include "probe_analysis.hpp"
#include "time_out.hpp"
#include "parameter.hpp"
#include "bed_file.hpp"
#include "cgi_analysis.hpp"

void dmr_analysis(Data_description &data_des,
    Data_matrix *data,
    Parameter &param,
    vector<Point> &ann,
    map<string, size_t> &map_probe,
    CGI_description &cgi_des,
    CGI_result &cgi_res);
#endif
